diff -Naur openssl-1.0.0q.orig/crypto/cast/c_enc.c openssl-1.0.0q/crypto/cast/c_enc.c
--- openssl-1.0.0q.orig/crypto/cast/c_enc.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/cast/c_enc.c	2017-04-25 16:23:40.117526666 +0200
@@ -56,6 +56,8 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPENSSL_NO_CAST
+
 #include <openssl/cast.h>
 #include "cast_lcl.h"
 
@@ -206,3 +208,4 @@
 	tin0=tin1=tout0=tout1=xor0=xor1=0;
 	tin[0]=tin[1]=0;
 	}
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/cast/c_skey.c openssl-1.0.0q/crypto/cast/c_skey.c
--- openssl-1.0.0q.orig/crypto/cast/c_skey.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/cast/c_skey.c	2017-04-25 16:23:40.118527072 +0200
@@ -56,6 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPENSSL_NO_CAST
+
+#include <openssl/crypto.h>
 #include <openssl/cast.h>
 #include "cast_lcl.h"
 #include "cast_s.h"
@@ -164,3 +167,4 @@
 		}
 	}
 
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/cast/cast_lcl.h openssl-1.0.0q/crypto/cast/cast_lcl.h
--- openssl-1.0.0q.orig/crypto/cast/cast_lcl.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/cast/cast_lcl.h	2017-04-25 16:23:40.119528037 +0200
@@ -57,10 +57,12 @@
  */
 
 
-#include "e_os.h"
+#include <openssl/e_os.h>
 
 #ifdef OPENSSL_SYS_WIN32
+#ifndef OPERA_SMALL_VERSION
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 
 
diff -Naur openssl-1.0.0q.orig/crypto/cast/cast_spd.c openssl-1.0.0q/crypto/cast/cast_spd.c
--- openssl-1.0.0q.orig/crypto/cast/cast_spd.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/cast/cast_spd.c	2017-04-25 16:23:40.119528037 +0200
@@ -63,6 +63,7 @@
 #define TIMES
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 
 #include <openssl/e_os2.h>
@@ -98,6 +99,7 @@
 #include <limits.h>
 #include <sys/param.h>
 #endif
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/cast.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/cast/castopts.c openssl-1.0.0q/crypto/cast/castopts.c
--- openssl-1.0.0q.orig/crypto/cast/castopts.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/cast/castopts.c	2017-04-25 16:23:40.120526488 +0200
@@ -63,6 +63,7 @@
 #define TIMES
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 
 #include <openssl/e_os2.h>
@@ -98,6 +99,7 @@
 #include <limits.h>
 #include <sys/param.h>
 #endif
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/cast.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/cast/casts.cpp openssl-1.0.0q/crypto/cast/casts.cpp
--- openssl-1.0.0q.orig/crypto/cast/casts.cpp	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/cast/casts.cpp	2017-04-25 16:23:40.121526895 +0200
@@ -30,8 +30,10 @@
 }
 #endif      
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif // !OPERA_SMALL_VERSION
 #include <openssl/cast.h>
 
 void main(int argc,char *argv[])
diff -Naur openssl-1.0.0q.orig/crypto/cast/casttest.c openssl-1.0.0q/crypto/cast/casttest.c
--- openssl-1.0.0q.orig/crypto/cast/casttest.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/cast/casttest.c	2017-04-25 16:23:40.122526463 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/opensslconf.h> /* To see if OPENSSL_NO_CAST is defined */
 
 #include "../e_os.h"
@@ -145,7 +147,7 @@
 	CAST_set_key(&key,k_len[z],k);
 
 	CAST_ecb_encrypt(in,out,&key,CAST_ENCRYPT);
-	if (memcmp(out,&(c[z][0]),8) != 0)
+	if (op_memcmp(out,&(c[z][0]),8) != 0)
 	    {
 	    printf("ecb cast error encrypting for keysize %d\n",k_len[z]*8);
 	    printf("got     :");
@@ -160,7 +162,7 @@
 	    }
 
 	CAST_ecb_encrypt(out,out,&key,CAST_DECRYPT);
-	if (memcmp(out,in,8) != 0)
+	if (op_memcmp(out,in,8) != 0)
 	    {
 	    printf("ecb cast error decrypting for keysize %d\n",k_len[z]*8);
 	    printf("got     :");
@@ -184,8 +186,8 @@
       
       printf("This test will take some time....");
       fflush(stdout);
-      memcpy(out_a,in_a,sizeof(in_a));
-      memcpy(out_b,in_b,sizeof(in_b));
+      op_memcpy(out_a,in_a,sizeof(in_a));
+      op_memcpy(out_b,in_b,sizeof(in_b));
       i=1;
 
       for (l=0; l<1000000L; l++)
@@ -204,8 +206,8 @@
 	      }
 	  }
 
-      if (	(memcmp(out_a,c_a,sizeof(c_a)) != 0) ||
-		(memcmp(out_b,c_b,sizeof(c_b)) != 0))
+      if (	(op_memcmp(out_a,c_a,sizeof(c_a)) != 0) ||
+		(op_memcmp(out_b,c_b,sizeof(c_b)) != 0))
 	  {
 	  printf("\n");
 	  printf("Error\n");
diff -Naur openssl-1.0.0q.orig/crypto/cms/.gitignore openssl-1.0.0q/crypto/cms/.gitignore
--- openssl-1.0.0q.orig/crypto/cms/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/cms/.gitignore	2017-04-25 16:23:40.124526159 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/comp/.gitignore openssl-1.0.0q/crypto/comp/.gitignore
--- openssl-1.0.0q.orig/crypto/comp/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/comp/.gitignore	2017-04-25 16:23:40.124526159 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/comp/c_rle.c openssl-1.0.0q/crypto/comp/c_rle.c
--- openssl-1.0.0q.orig/crypto/comp/c_rle.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/comp/c_rle.c	2017-04-25 16:23:40.125526286 +0200
@@ -1,6 +1,8 @@
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/objects.h>
 #include <openssl/comp.h>
 
@@ -37,7 +39,7 @@
 		}
 
 	*(out++)=0;
-	memcpy(out,in,ilen);
+	op_memcpy(out,in,ilen);
 	return(ilen+1);
 	}
 
@@ -55,7 +57,7 @@
 	i= *(in++);
 	if (i == 0)
 		{
-		memcpy(out,in,ilen-1);
+		op_memcpy(out,in,ilen-1);
 		}
 	return(ilen-1);
 	}
diff -Naur openssl-1.0.0q.orig/crypto/comp/c_zlib.c openssl-1.0.0q/crypto/comp/c_zlib.c
--- openssl-1.0.0q.orig/crypto/comp/c_zlib.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/comp/c_zlib.c	2017-04-25 16:23:40.126526134 +0200
@@ -1,6 +1,8 @@
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/objects.h>
 #include <openssl/comp.h>
 #include <openssl/err.h>
@@ -88,6 +90,7 @@
  * and we do not link to a .LIB file when ZLIB_SHARED is set.
  */
 #if defined(OPENSSL_SYS_WINDOWS) || defined(OPENSSL_SYS_WIN32)
+#ifndef OPERA_SMALL_VERSION
 # include <windows.h>
 #endif /* !(OPENSSL_SYS_WINDOWS || OPENSSL_SYS_WIN32) */
 
@@ -267,7 +270,7 @@
 	if (clear)
 		{
 		out[0]=0;
-		memcpy(&(out[1]),in,ilen);
+		op_memcpy(&(out[1]),in,ilen);
 		l=ilen+1;
 		}
 #ifdef DEBUG_ZLIB
@@ -292,7 +295,7 @@
 		}
 	else
 		{
-		memcpy(out,&(in[1]),ilen-1);
+		op_memcpy(out,&(in[1]),ilen-1);
 		l=ilen-1;
 		}
 #ifdef DEBUG_ZLIB
diff -Naur openssl-1.0.0q.orig/crypto/comp/comp_err.c openssl-1.0.0q/crypto/comp/comp_err.c
--- openssl-1.0.0q.orig/crypto/comp/comp_err.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/comp/comp_err.c	2017-04-25 16:23:40.127526540 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/comp.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/comp/comp_lib.c openssl-1.0.0q/crypto/comp/comp_lib.c
--- openssl-1.0.0q.orig/crypto/comp/comp_lib.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/comp/comp_lib.c	2017-04-25 16:23:40.128527226 +0200
@@ -1,6 +1,8 @@
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/objects.h>
 #include <openssl/comp.h>
 
@@ -13,7 +15,7 @@
 		/* ZZZZZZZZZZZZZZZZ */
 		return(NULL);
 		}
-	memset(ret,0,sizeof(COMP_CTX));
+	op_memset(ret,0,sizeof(COMP_CTX));
 	ret->meth=meth;
 	if ((ret->meth->init != NULL) && !ret->meth->init(ret))
 		{
diff -Naur openssl-1.0.0q.orig/crypto/conf/.gitignore openssl-1.0.0q/crypto/conf/.gitignore
--- openssl-1.0.0q.orig/crypto/conf/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/conf/.gitignore	2017-04-25 16:23:40.128527226 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/conf/cnf_save.c openssl-1.0.0q/crypto/conf/cnf_save.c
--- openssl-1.0.0q.orig/crypto/conf/cnf_save.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/conf/cnf_save.c	2017-04-25 16:23:40.129526515 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/conf.h>
 
 static void print_conf(CONF_VALUE *cv);
diff -Naur openssl-1.0.0q.orig/crypto/conf/conf.h openssl-1.0.0q/crypto/conf/conf.h
--- openssl-1.0.0q.orig/crypto/conf/conf.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/conf/conf.h	2017-04-25 16:23:40.132527176 +0200
@@ -134,7 +134,9 @@
 long CONF_get_number(LHASH_OF(CONF_VALUE) *conf,const char *group,
 		     const char *name);
 void CONF_free(LHASH_OF(CONF_VALUE) *conf);
+#ifndef OPENSSL_NO_FP_API
 int CONF_dump_fp(LHASH_OF(CONF_VALUE) *conf, FILE *out);
+#endif
 int CONF_dump_bio(LHASH_OF(CONF_VALUE) *conf, BIO *out);
 
 void OPENSSL_config(const char *config_name);
@@ -168,7 +170,9 @@
 char *NCONF_get_string(const CONF *conf,const char *group,const char *name);
 int NCONF_get_number_e(const CONF *conf,const char *group,const char *name,
 		       long *result);
+#ifndef OPENSSL_NO_FP_API
 int NCONF_dump_fp(const CONF *conf, FILE *out);
+#endif
 int NCONF_dump_bio(const CONF *conf, BIO *out);
 
 #if 0 /* The following function has no error checking,
diff -Naur openssl-1.0.0q.orig/crypto/conf/conf_api.c openssl-1.0.0q/crypto/conf/conf_api.c
--- openssl-1.0.0q.orig/crypto/conf/conf_api.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/conf/conf_api.c	2017-04-25 16:23:40.133527861 +0200
@@ -63,9 +63,11 @@
 # define NDEBUG
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <assert.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/conf.h>
 #include <openssl/conf_api.h>
 #include "e_os.h"
@@ -129,7 +131,8 @@
 char *_CONF_get_string(const CONF *conf, const char *section, const char *name)
 	{
 	CONF_VALUE *v,vv;
-	char *p;
+	const char *p;
+
 
 	if (name == NULL) return(NULL);
 	if (conf != NULL)
@@ -140,7 +143,7 @@
 			vv.section=(char *)section;
 			v=lh_CONF_VALUE_retrieve(conf->data,&vv);
 			if (v != NULL) return(v->value);
-			if (strcmp(section,"ENV") == 0)
+			if (op_strcmp(section,"ENV") == 0)
 				{
 				p=getenv(name);
 				if (p != NULL) return(p);
@@ -191,13 +194,13 @@
 
 	if (a->section != b->section)
 		{
-		i=strcmp(a->section,b->section);
+		i=op_strcmp(a->section,b->section);
 		if (i) return(i);
 		}
 
 	if ((a->name != NULL) && (b->name != NULL))
 		{
-		i=strcmp(a->name,b->name);
+		i=op_strcmp(a->name,b->name);
 		return(i);
 		}
 	else if (a->name == b->name)
@@ -278,10 +281,10 @@
 	if ((v=OPENSSL_malloc(sizeof(CONF_VALUE))) == NULL)
 		goto err;
 	i=strlen(section)+1;
-	if ((v->section=OPENSSL_malloc(i)) == NULL)
+	if ((v->section=(char *)OPENSSL_malloc(i)) == NULL)
 		goto err;
 
-	memcpy(v->section,section,i);
+	op_memcpy(v->section,section,i);
 	v->name=NULL;
 	v->value=(char *)sk;
 	
diff -Naur openssl-1.0.0q.orig/crypto/conf/conf_def.c openssl-1.0.0q/crypto/conf/conf_def.c
--- openssl-1.0.0q.orig/crypto/conf/conf_def.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/conf/conf_def.c	2017-04-25 16:23:40.134527150 +0200
@@ -58,11 +58,15 @@
 
 /* Part of the code in here was originally in conf.c, which is now removed */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/stack.h>
-#include <openssl/lhash.h>
 #include <openssl/conf.h>
 #include <openssl/conf_api.h>
 #include "conf_def.h"
@@ -90,7 +94,7 @@
 
 const char CONF_def_version[]="CONF_def" OPENSSL_VERSION_PTEXT;
 
-static CONF_METHOD default_method = {
+static const CONF_METHOD default_method = {
 	"OpenSSL default",
 	def_create,
 	def_init_default,
@@ -103,7 +107,7 @@
 	def_load
 	};
 
-static CONF_METHOD WIN32_method = {
+static const CONF_METHOD WIN32_method = {
 	"WIN32",
 	def_create,
 	def_init_WIN32,
@@ -263,7 +267,7 @@
 		*p='\0';
 		BIO_gets(in, p, CONFBUFSIZE-1);
 		p[CONFBUFSIZE-1]='\0';
-		ii=i=strlen(p);
+		ii=i=op_strlen(p);
 		if (i == 0 && !again) break;
 		again=0;
 		while (i > 0)
@@ -380,7 +384,7 @@
 				goto err;
 				}
 			if (psection == NULL) psection=section;
-			v->name=(char *)OPENSSL_malloc(strlen(pname)+1);
+			v->name=(char *)OPENSSL_malloc(op_strlen(pname)+1);
 			v->value=NULL;
 			if (v->name == NULL)
 				{
@@ -391,7 +395,7 @@
 			BUF_strlcpy(v->name,pname,strlen(pname)+1);
 			if (!str_copy(conf,psection,&(v->value),start)) goto err;
 
-			if (strcmp(psection,section) != 0)
+			if (op_strcmp(psection,section) != 0)
 				{
 				if ((tv=_CONF_get_section(conf,psection))
 					== NULL)
@@ -508,7 +512,7 @@
 
 	if ((buf=BUF_MEM_new()) == NULL) return(0);
 
-	len=strlen(from)+1;
+	len=op_strlen(from)+1;
 	if (!BUF_MEM_grow(buf,len)) goto err;
 
 	for (;;)
@@ -618,7 +622,7 @@
 				CONFerr(CONF_F_STR_COPY,CONF_R_VARIABLE_HAS_NO_VALUE);
 				goto err;
 				}
-			BUF_MEM_grow_clean(buf,(strlen(p)+buf->length-(e-from)));
+			BUF_MEM_grow_clean(buf,(op_strlen(p)+buf->length-(e-from)));
 			while (*p)
 				buf->data[to++]= *(p++);
 
diff -Naur openssl-1.0.0q.orig/crypto/conf/conf_def.h openssl-1.0.0q/crypto/conf/conf_def.h
--- openssl-1.0.0q.orig/crypto/conf/conf_def.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/conf/conf_def.h	2017-04-25 16:23:40.135527557 +0200
@@ -108,7 +108,7 @@
 #define IS_HIGHBIT(c,a)		(KEYTYPES(c)[os_toascii[a]&0xff]&CONF_HIGHBIT)
 #endif /*CHARSET_EBCDIC*/
 
-static unsigned short CONF_type_default[256]={
+static const unsigned short CONF_type_default[256]={
 	0x0008,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
 	0x0000,0x0010,0x0010,0x0000,0x0000,0x0010,0x0000,0x0000,
 	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
@@ -143,7 +143,7 @@
 	0x1000,0x1000,0x1000,0x1000,0x1000,0x1000,0x1000,0x1000,
 	};
 
-static unsigned short CONF_type_win32[256]={
+static const unsigned short CONF_type_win32[256]={
 	0x0008,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
 	0x0000,0x0010,0x0010,0x0000,0x0000,0x0010,0x0000,0x0000,
 	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
diff -Naur openssl-1.0.0q.orig/crypto/conf/conf_err.c openssl-1.0.0q/crypto/conf/conf_err.c
--- openssl-1.0.0q.orig/crypto/conf/conf_err.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/conf/conf_err.c	2017-04-25 16:23:40.136527405 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/conf.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/conf/conf_lib.c openssl-1.0.0q/crypto/conf/conf_lib.c
--- openssl-1.0.0q.orig/crypto/conf/conf_lib.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/conf/conf_lib.c	2017-04-25 16:23:40.137527532 +0200
@@ -56,16 +56,23 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include <openssl/crypto.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/conf.h>
 #include <openssl/conf_api.h>
 #include <openssl/lhash.h>
 
-const char CONF_version[]="CONF" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char CONF_version[]="CONF" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2008-02-26 haavardm */
 
+#ifdef _NO_GLOBALS_
+extern CONF_METHOD* *g_default_CONF_method_addr();
+#define default_CONF_method (*g_default_CONF_method_addr())
+#else
 static CONF_METHOD *default_CONF_method=NULL;
+#endif
 
 /* Init a 'CONF' structure from an old LHASH */
 
@@ -405,3 +412,4 @@
 	return ret;
 	}
 #endif
+#endif /* OPERA_SMALL_VERSION */
diff -Naur openssl-1.0.0q.orig/crypto/conf/conf_mall.c openssl-1.0.0q/crypto/conf/conf_mall.c
--- openssl-1.0.0q.orig/crypto/conf/conf_mall.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/conf/conf_mall.c	2017-04-25 16:23:40.138527659 +0200
@@ -56,7 +56,9 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/crypto.h>
 #include "cryptlib.h"
 #include <openssl/conf.h>
diff -Naur openssl-1.0.0q.orig/crypto/conf/conf_mod.c openssl-1.0.0q/crypto/conf/conf_mod.c
--- openssl-1.0.0q.orig/crypto/conf/conf_mod.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/conf/conf_mod.c	2017-04-25 16:23:40.139527507 +0200
@@ -56,15 +56,19 @@
  *
  */
 
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <ctype.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/crypto.h>
-#include "cryptlib.h"
 #include <openssl/conf.h>
 #include <openssl/dso.h>
 #include <openssl/x509.h>
 
-
+#ifndef OPERA_SMALL_VERSION
 #define DSO_mod_init_name "OPENSSL_init"
 #define DSO_mod_finish_name "OPENSSL_finish"
 
@@ -325,17 +329,17 @@
 	CONF_MODULE *tmod;
 	int i, nchar;
 	char *p;
-	p = strrchr(name, '.');
+	p = op_strrchr(name, '.');
 
 	if (p)
 		nchar = p - name;
 	else 
-		nchar = strlen(name);
+		nchar = op_strlen(name);
 
 	for (i = 0; i < sk_CONF_MODULE_num(supported_modules); i++)
 		{
 		tmod = sk_CONF_MODULE_value(supported_modules, i);
-		if (!strncmp(tmod->name, name, nchar))
+		if (!op_strncmp(tmod->name, name, nchar))
 			return tmod;
 		}
 
@@ -552,11 +556,11 @@
 	if (file) 
 		return BUF_strdup(file);
 
-	len = strlen(X509_get_default_cert_area());
+	len = op_strlen(X509_get_default_cert_area());
 #ifndef OPENSSL_SYS_VMS
 	len++;
 #endif
-	len += strlen(OPENSSL_CONF);
+	len += op_strlen(OPENSSL_CONF);
 
 	file = OPENSSL_malloc(len + 1);
 
@@ -570,6 +574,7 @@
 
 	return file;
 	}
+#endif // !OPERA_SMALL_VERSION
 
 /* This function takes a list separated by 'sep' and calls the
  * callback function giving the start and length of each member
@@ -594,10 +599,10 @@
 		{
 		if (nospc)
 			{
-			while(*lstart && isspace((unsigned char)*lstart))
+			while(*lstart && op_isspace((unsigned char)*lstart))
 				lstart++;
 			}
-		p = strchr(lstart, sep);
+		p = op_strchr(lstart, sep);
 		if (p == lstart || !*lstart)
 			ret = list_cb(NULL, 0, arg);
 		else
@@ -605,10 +610,10 @@
 			if (p)
 				tmpend = p - 1;
 			else 
-				tmpend = lstart + strlen(lstart) - 1;
+				tmpend = lstart + op_strlen(lstart) - 1;
 			if (nospc)
 				{
-				while(isspace((unsigned char)*tmpend))
+				while(op_isspace((unsigned char)*tmpend))
 					tmpend--;
 				}
 			ret = list_cb(lstart, tmpend - lstart + 1, arg);
diff -Naur openssl-1.0.0q.orig/crypto/conf/conf_sap.c openssl-1.0.0q/crypto/conf/conf_sap.c
--- openssl-1.0.0q.orig/crypto/conf/conf_sap.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/conf/conf_sap.c	2017-04-25 16:23:40.140527634 +0200
@@ -56,7 +56,9 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/crypto.h>
 #include "cryptlib.h"
 #include <openssl/conf.h>
diff -Naur openssl-1.0.0q.orig/crypto/conf/test.c openssl-1.0.0q/crypto/conf/test.c
--- openssl-1.0.0q.orig/crypto/conf/test.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/conf/test.c	2017-04-25 16:23:40.142527329 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/conf.h>
 #include <openssl/err.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/cpt_err.c openssl-1.0.0q/crypto/cpt_err.c
--- openssl-1.0.0q.orig/crypto/cpt_err.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/cpt_err.c	2017-04-25 16:23:40.143527177 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/crypto.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/cryptlib.c openssl-1.0.0q/crypto/cryptlib.c
--- openssl-1.0.0q.orig/crypto/cryptlib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/cryptlib.c	2017-04-25 16:23:40.144527583 +0200
@@ -114,15 +114,19 @@
  * SUN MICROSYSTEMS, INC., and contributed to the OpenSSL project.
  */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
+#include <openssl/crypto.h>
 #include <openssl/safestack.h>
 
+#ifndef OPERA_SMALL_VERSION
 #if defined(OPENSSL_SYS_WIN32) || defined(OPENSSL_SYS_WIN16)
 static double SSLeay_MSVC5_hack=0.0; /* and for VC1.5 */
 #endif
+#endif // !OPERA_SMALL_VERSION
 
 DECLARE_STACK_OF(CRYPTO_dynlock)
 
+#ifndef OPERA_SMALL_VERSION
 /* real #defines in crypto.h, keep these upto date */
 static const char* const lock_names[CRYPTO_NUM_LOCKS] =
 	{
@@ -196,7 +200,9 @@
 	struct CRYPTO_dynlock_value *l, const char *file,int line)=0;
 static void (MS_FAR *dynlock_destroy_callback)(struct CRYPTO_dynlock_value *l,
 	const char *file,int line)=0;
+#endif // !OPERA_SMALL_VERSION
 
+#ifndef OPERA_SMALL_VERSION
 int CRYPTO_get_new_lockid(char *name)
 	{
 	char *str;
@@ -227,12 +233,16 @@
 		i+=CRYPTO_NUM_LOCKS; /* gap of one :-) */
 	return(i);
 	}
+#endif // !OPERA_SMALL_VERSION
 
+#ifndef OPERA_SMALL_VERSION
 int CRYPTO_num_locks(void)
 	{
 	return CRYPTO_NUM_LOCKS;
 	}
+#endif // !OPERA_SMALL_VERSION
 
+#ifndef OPERA_SMALL_VERSION
 int CRYPTO_get_new_dynlockid(void)
 	{
 	int i = 0;
@@ -392,8 +402,10 @@
 	{
 	dynlock_destroy_callback=func;
 	}
+#endif // !OPERA_SMALL_VERSION
 
 
+#ifndef OPERA_SMALL_VERSION
 void (*CRYPTO_get_locking_callback(void))(int mode,int type,const char *file,
 		int line)
 	{
@@ -417,24 +429,25 @@
 	{
 	add_lock_callback=func;
 	}
+#endif // !OPERA_SMALL_VERSION
 
 /* the memset() here and in set_pointer() seem overkill, but for the sake of
  * CRYPTO_THREADID_cmp() this avoids any platform silliness that might cause two
  * "equal" THREADID structs to not be memcmp()-identical. */
 void CRYPTO_THREADID_set_numeric(CRYPTO_THREADID *id, unsigned long val)
 	{
-	memset(id, 0, sizeof(*id));
+	op_memset(id, 0, sizeof(*id));
 	id->val = val;
 	}
 
 static const unsigned char hash_coeffs[] = { 3, 5, 7, 11, 13, 17, 19, 23 };
 void CRYPTO_THREADID_set_pointer(CRYPTO_THREADID *id, void *ptr)
 	{
-	unsigned char *dest = (void *)&id->val;
+	unsigned char *dest = (unsigned char *)&id->val;
 	unsigned int accum = 0;
 	unsigned char dnum = sizeof(id->val);
 
-	memset(id, 0, sizeof(*id));
+	op_memset(id, 0, sizeof(*id));
 	id->ptr = ptr;
 	if (sizeof(id->val) >= sizeof(id->ptr))
 		{
@@ -454,7 +467,7 @@
 	 * mistake it as such. Plus I'm lazy. */
 	while (dnum--)
 		{
-		const unsigned char *src = (void *)&id->ptr;
+		const unsigned char *src = (const unsigned char *)&id->ptr;
 		unsigned char snum = sizeof(id->ptr);
 		while (snum--)
 			accum += *(src++) * hash_coeffs[(snum + dnum) & 7];
@@ -463,6 +476,7 @@
 		}
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int CRYPTO_THREADID_set_callback(void (*func)(CRYPTO_THREADID *))
 	{
 	if (threadid_callback)
@@ -475,9 +489,11 @@
 	{
 	return threadid_callback;
 	}
+#endif // !OPERA_SMALL_VERSION
 
 void CRYPTO_THREADID_current(CRYPTO_THREADID *id)
 	{
+#ifndef OPERA_SMALL_VERSION
 	if (threadid_callback)
 		{
 		threadid_callback(id);
@@ -491,6 +507,7 @@
 		return;
 		}
 #endif
+#endif // !OPERA_SMALL_VERSION
 	/* Else pick a backup */
 #ifdef OPENSSL_SYS_WIN16
 	CRYPTO_THREADID_set_numeric(id, (unsigned long)GetCurrentTask());
@@ -500,18 +517,23 @@
 	CRYPTO_THREADID_set_numeric(id, (unsigned long)find_thread(NULL));
 #else
 	/* For everything else, default to using the address of 'errno' */
+#ifdef HAVE_ERRNO
 	CRYPTO_THREADID_set_pointer(id, (void*)&errno);
+#else
+	// Fallback for platforms not having 'errno'.
+	CRYPTO_THREADID_set_pointer(id, NULL);
+#endif // HAVE_ERRNO
 #endif
 	}
 
 int CRYPTO_THREADID_cmp(const CRYPTO_THREADID *a, const CRYPTO_THREADID *b)
 	{
-	return memcmp(a, b, sizeof(*a));
+	return op_memcmp(a, b, sizeof(*a));
 	}
 
 void CRYPTO_THREADID_cpy(CRYPTO_THREADID *dest, const CRYPTO_THREADID *src)
 	{
-	memcpy(dest, src, sizeof(*src));
+	op_memcpy(dest, src, sizeof(*src));
 	}
 
 unsigned long CRYPTO_THREADID_hash(const CRYPTO_THREADID *id)
@@ -581,6 +603,8 @@
 			CRYPTO_get_lock_name(type), file, line);
 		}
 #endif
+#ifndef OPERA_SMALL_VERSION
+#ifndef _NO_GLOBALS_
 	if (type < 0)
 		{
 		if (dynlock_lock_callback != NULL)
@@ -598,6 +622,8 @@
 	else
 		if (locking_callback != NULL)
 			locking_callback(mode,type,file,line);
+#endif // !_NO_GLOBALS_
+#endif // !OPERA_SMALL_VERSION
 	}
 
 int CRYPTO_add_lock(int *pointer, int amount, int type, const char *file,
@@ -605,6 +631,8 @@
 	{
 	int ret = 0;
 
+#ifndef OPERA_SMALL_VERSION
+#ifndef _NO_GLOBALS_
 	if (add_lock_callback != NULL)
 		{
 #ifdef LOCK_DEBUG
@@ -624,6 +652,8 @@
 #endif
 		}
 	else
+#endif // !_NO_GLOBALS_
+#endif // !OPERA_SMALL_VERSION
 		{
 		CRYPTO_lock(CRYPTO_LOCK|CRYPTO_WRITE,type,file,line);
 
@@ -645,6 +675,7 @@
 	return(ret);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 const char *CRYPTO_get_lock_name(int type)
 	{
 	if (type < 0)
@@ -656,7 +687,9 @@
 	else
 		return(sk_OPENSSL_STRING_value(app_locks,type-CRYPTO_NUM_LOCKS));
 	}
+#endif // !OPERA_SMALL_VERSION
 
+#ifndef OPERA_SMALL_VERSION
 #if	defined(__i386)   || defined(__i386__)   || defined(_M_IX86) || \
 	defined(__INTEL__) || \
 	defined(__x86_64) || defined(__x86_64__) || defined(_M_AMD64) || defined(_M_X64)
@@ -896,16 +929,4 @@
 	}
 
 void *OPENSSL_stderr(void)	{ return stderr; }
-
-int CRYPTO_memcmp(const void *in_a, const void *in_b, size_t len)
-	{
-	size_t i;
-	const unsigned char *a = in_a;
-	const unsigned char *b = in_b;
-	unsigned char x = 0;
-
-	for (i = 0; i < len; i++)
-		x |= a[i] ^ b[i];
-
-	return x;
-	}
+#endif // !OPERA_SMALL_VERSION
diff -Naur openssl-1.0.0q.orig/crypto/cryptlib.h openssl-1.0.0q/crypto/cryptlib.h
--- openssl-1.0.0q.orig/crypto/cryptlib.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/cryptlib.h	2017-04-25 16:23:40.145527710 +0200
@@ -59,10 +59,95 @@
 #ifndef HEADER_CRYPTLIB_H
 #define HEADER_CRYPTLIB_H
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
-#include "e_os.h"
+#include <openssl/e_os.h>
+
+#if defined(_SSL_USE_OPENSSL_) || defined(LIBOPEAY_ENABLE_PARTLY_OPENSSL_SUPPORT)
+
+#if defined(WIN32) && !defined(SIXTY_FOUR_BIT) && !defined(THIRTY_TWO_BIT)
+#define THIRTY_TWO_BIT
+#elif !defined(THIRTY_TWO_BIT) && !defined(SIXTY_FOUR_BIT) && !defined(SIXTEEN_BIT) && !defined(EIGHT_BIT)
+#error One of these MUST be defined
+#endif
+
+
+#define OPENSSL_NO_CAMELLIA
+#define OPENSSL_NO_CMS
+#define OPENSSL_NO_SOCK
+#define OPENSSL_NO_DEPRECATED
+/*#define OPENSSL_NO_BIO */
+#define OPENSSL_NO_FP_API
+#define OPENSSL_NO_IDEA
+#define OPENSSL_NO_ENGINE
+#define OPENSSL_NO_EC
+#define OPENSSL_NO_ECDH
+#define OPENSSL_NO_ECDSA
+#define OPENSSL_NO_SEED
+//#define OPENSSL_NO_SHA256
+//#define OPENSSL_NO_SHA512
+#define OPENSSL_NO_SHA0
+#define NO_OLD_ASN1
+#define OPENSSL_NO_STDIO
+#define OPENSSL_DISABLE_OLD_DES_SUPPORT
+
+#define OPENSSL_SMALL_FOOTPRINT
+#define NO_ASN1_FIELD_NAMES
+
+#ifndef USE_SYSTEM_ASSERT
+#undef assert
+#define assert(x) OP_ASSERT(x)
+#endif // USE_SYSTEM_ASSERT
+
+#ifndef SSL_BLOWFISH_SUPPORT
+#define OPENSSL_NO_BF
+#endif
+
+#if !(defined(NEED_LIBOPEAY_CAST_RIPE_SUPPORT))
+/*#define OPENSSL_NO_AES*/
+#define OPENSSL_NO_CAST
+#define OPENSSL_NO_RIPEMD
+#endif
+#if defined(NEED_LIBOPEAY_CFB_SUPPORT)
+#define OPENSSL_USE_CFB_CIPHERS
+#endif
+#if !defined(__SSL_WITH_DH_DSA__)
+#define OPENSSL_NO_DSA
+#define OPENSSL_NO_DH
+#endif
+#define OPENSSL_NO_MD2
+#define OPENSSL_NO_MDC2
+#define OPENSSL_NO_MD4
+#define OPENSSL_NO_RC5
+#define OPENSSL_NO_WHIRLPOOL
+
+/*#define OPENSSL_NO_OCSP */
+
+#define NO_CONF
+#if !defined SSL_USE_WEAK_CIPHERS
+#define NO_SINGLE_DES
+#endif
+#if !defined SSL_USE_WEAK_CIPHERS && !defined SSL_2_0_SUPPORT && !defined LIBOPEAY_PKCS12_SUPPORT
+#define OPENSSL_NO_RC2
+#endif
+#define DES_PART_ONLY
+#define NO_ERR
+#define OPENSSL_NO_ERR
+
+#ifdef EXTERNAL_SSL_OPENSSL_IMPLEMENTATION
+#define OPENSSL_NO_COMP
+#define OPENSSL_NO_DTLS1
+#define OPENSSL_NO_ECB
+#endif // EXTERNAL_SSL_OPENSSL_IMPLEMENTATION
+
+
+#define OPERA_OPENSSL_STRINGS(x) ((const char *) NULL)
+#else
+#define OPERA_OPENSSL_STRINGS(x) x
+#endif /* _SSL_USE_OPENSSL_ || LIBOPEAY_ENABLE_PARTLY_OPENSSL_SUPPORT */
 
 #ifdef OPENSSL_USE_APPLINK
 #define BIO_FLAGS_UPLINK 0x8000
